                                           ╘
                                    ─       ╛▒╛
                                     ▐╫       ▄█├
                              ─╟╛      █▄      ╪▓▀
                    ╓┤┤┤┤┤┤┤┤┤  ╩▌      ██      ▀▓▌
                     ▐▒   ╬▒     ╟▓╘    ─▓█      ▓▓├
                     ▒╫   ▒╪      ▓█     ▓▓─     ▓▓▄
                    ╒▒─  │▒       ▓█     ▓▓     ─▓▓─
                    ╬▒   ▄▒ ╒    ╪▓═    ╬▓╬     ▌▓▄
                    ╥╒   ╦╥     ╕█╒    ╙▓▐     ▄▓╫
                               ▐╩     ▒▒      ▀▀
                                    ╒╪      ▐▄
             
                 _____             __        ____  __
                / ___/____  ____  /_/____   / __ \/_/
                \__ \/ __ \/ __ \/ / ___/  / /_/ / /
               ___/ / /_/ / / / / / /__   / ____/ /
              /____/\____/_/ /_/_/\___/  /_/   /_/


## The Live Coding Synth for Everyone.

Sonic Pi is a *new kind of musical instrument*. Instead of strumming
strings or whacking things with sticks - you write code - **live**.

Sonic Pi has been designed with the aim to find a harmonious balance
between three core principles:

* **Simple** enough for the 10 year old within you
* **Joyful** enough for you to lose yourself through play
* **Powerful** enough for your own expressions

Sonic Pi is a complete open source programming environment originally
designed to explore and *teach programming concepts* within schools through 
the process of creating *new sounds*. 

In addition to being an engaging education resource it has evolved into 
an *extremely powerful* and performance-ready *live coding instrument* suitable 
for professional artists and DJs.

Whilst Education is a core focus it now sits at the intersection
between three core domains:

* **Art** - providing the means to express yourself and ask new questions of music and notation
* **Technology** - exploring questions related to liveness, time and concurrency in programming languages
* **Education**  - demonstrating that open play rather than rigid structures increases motivation and engagement in the classroom

Again, finding a balance working to the best benefits of all these
domains is the objective.


* Info & Latest Releases: http://sonic-pi.net
* Source: https://github.com/samaaron/sonic-pi
* Computing Education Resources for Schools: http://www.raspberrypi.org/learning/sonic-pi-lessons/
* Music Education Toolkit for Schools: http://sonicpiliveandcoding.com

## Acknowledgements

Sonic Pi has been developed within the Computer Laboratory at the
University of Cambridge with kind support from the Raspberry Pi
Foundation and the Broadcom Foundation.

## Translations

Sonic Pi's built in tutorial has been translated into several languages thanks to the awesome work of the following contributors.

\-           | Language      | Status      | Maintainer   | Contributors |
------------ | ------------- | ----------  | ------------ | ------------ |
:fr:         | French        | merged      |              | @echevresm, @nicoder, @SergeStinckwich |
:de:         | German        | merged      |              | @hzulla, G. Martin Butz, @hztirf, @mbutz, @wwerner, @st01c |
:jp:         | Japanese      | merged      |              | @keikomachiya |
:pl:         | Polish        | merged      | @hopbit      | @hopbit, @nurkiewicz |
:it:         | Italian       | in progress |              | @marco-giordano |
:ru:         | Russian       | in progress |              | @RomanSaveljev, @dcromster |
:pt:         | Portuguese    | in progress |              | @SiIky |
:sp:         | Spanish       | in progress |              | @merongivian, @thraex41 |
:nl:         | Dutch         | in progress | @DuchessFounder | @DuchessFounder, @PrisDiest |
:gr:         | Greek         | in progress | @aspra       | @aspra |
:nb:         | Norwegian Bokmål | in progress | @petterreinholdtsen | @petterreinholdtsen |

Would you like to contribute a translation too? If so, please take a look at our [translation docs](https://github.com/samaaron/sonic-pi/blob/master/TRANSLATION.md) to get started. Additionally [here](https://github.com/samaaron/sonic-pi/issues?utf8=%E2%9C%93&q=is%3Aissue+is%3Aopen+i18n) you can find translations (i18n) related issues.

## Information for developers

Sonic Pi is under active development, and welcomes new contributors:

* [How to contribute](HOW-TO-CONTRIBUTE.md)
* [Change log](CHANGELOG.md)
* [Community](COMMUNITY.md)
* [Contributors](CONTRIBUTORS.md)
* [Installation](INSTALL.md)
* [License](LICENSE.md)
* [Testing](TESTING.md)
* [Translation](TRANSLATION.md)

[![Gitter](https://badges.gitter.im/Join%20Chat.svg)](https://gitter.im/samaaron/sonic-pi?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)
<br/>
<img src="https://travis-ci.org/samaaron/sonic-pi.svg?branch=master"/>
